require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&VMX_H)) {
    eval 'sub VMX_H () {1;}' unless defined(&VMX_H);
    eval 'sub CPU_BASED_VIRTUAL_INTR_PENDING () {0x4;}' unless defined(&CPU_BASED_VIRTUAL_INTR_PENDING);
    eval 'sub CPU_BASED_USE_TSC_OFFSETING () {0x8;}' unless defined(&CPU_BASED_USE_TSC_OFFSETING);
    eval 'sub CPU_BASED_HLT_EXITING () {0x80;}' unless defined(&CPU_BASED_HLT_EXITING);
    eval 'sub CPU_BASED_INVLPG_EXITING () {0x200;}' unless defined(&CPU_BASED_INVLPG_EXITING);
    eval 'sub CPU_BASED_MWAIT_EXITING () {0x400;}' unless defined(&CPU_BASED_MWAIT_EXITING);
    eval 'sub CPU_BASED_RDPMC_EXITING () {0x800;}' unless defined(&CPU_BASED_RDPMC_EXITING);
    eval 'sub CPU_BASED_RDTSC_EXITING () {0x1000;}' unless defined(&CPU_BASED_RDTSC_EXITING);
    eval 'sub CPU_BASED_CR3_LOAD_EXITING () {0x8000;}' unless defined(&CPU_BASED_CR3_LOAD_EXITING);
    eval 'sub CPU_BASED_CR3_STORE_EXITING () {0x10000;}' unless defined(&CPU_BASED_CR3_STORE_EXITING);
    eval 'sub CPU_BASED_CR8_LOAD_EXITING () {0x80000;}' unless defined(&CPU_BASED_CR8_LOAD_EXITING);
    eval 'sub CPU_BASED_CR8_STORE_EXITING () {0x100000;}' unless defined(&CPU_BASED_CR8_STORE_EXITING);
    eval 'sub CPU_BASED_TPR_SHADOW () {0x200000;}' unless defined(&CPU_BASED_TPR_SHADOW);
    eval 'sub CPU_BASED_VIRTUAL_NMI_PENDING () {0x400000;}' unless defined(&CPU_BASED_VIRTUAL_NMI_PENDING);
    eval 'sub CPU_BASED_MOV_DR_EXITING () {0x800000;}' unless defined(&CPU_BASED_MOV_DR_EXITING);
    eval 'sub CPU_BASED_UNCOND_IO_EXITING () {0x1000000;}' unless defined(&CPU_BASED_UNCOND_IO_EXITING);
    eval 'sub CPU_BASED_USE_IO_BITMAPS () {0x2000000;}' unless defined(&CPU_BASED_USE_IO_BITMAPS);
    eval 'sub CPU_BASED_USE_MSR_BITMAPS () {0x10000000;}' unless defined(&CPU_BASED_USE_MSR_BITMAPS);
    eval 'sub CPU_BASED_MONITOR_EXITING () {0x20000000;}' unless defined(&CPU_BASED_MONITOR_EXITING);
    eval 'sub CPU_BASED_PAUSE_EXITING () {0x40000000;}' unless defined(&CPU_BASED_PAUSE_EXITING);
    eval 'sub CPU_BASED_ACTIVATE_SECONDARY_CONTROLS () {0x80000000;}' unless defined(&CPU_BASED_ACTIVATE_SECONDARY_CONTROLS);
    eval 'sub SECONDARY_EXEC_VIRTUALIZE_APIC_ACCESSES () {0x1;}' unless defined(&SECONDARY_EXEC_VIRTUALIZE_APIC_ACCESSES);
    eval 'sub SECONDARY_EXEC_ENABLE_EPT () {0x2;}' unless defined(&SECONDARY_EXEC_ENABLE_EPT);
    eval 'sub SECONDARY_EXEC_ENABLE_VPID () {0x20;}' unless defined(&SECONDARY_EXEC_ENABLE_VPID);
    eval 'sub SECONDARY_EXEC_WBINVD_EXITING () {0x40;}' unless defined(&SECONDARY_EXEC_WBINVD_EXITING);
    eval 'sub SECONDARY_EXEC_UNRESTRICTED_GUEST () {0x80;}' unless defined(&SECONDARY_EXEC_UNRESTRICTED_GUEST);
    eval 'sub PIN_BASED_EXT_INTR_MASK () {0x1;}' unless defined(&PIN_BASED_EXT_INTR_MASK);
    eval 'sub PIN_BASED_NMI_EXITING () {0x8;}' unless defined(&PIN_BASED_NMI_EXITING);
    eval 'sub PIN_BASED_VIRTUAL_NMIS () {0x20;}' unless defined(&PIN_BASED_VIRTUAL_NMIS);
    eval 'sub VM_EXIT_HOST_ADDR_SPACE_SIZE () {0x200;}' unless defined(&VM_EXIT_HOST_ADDR_SPACE_SIZE);
    eval 'sub VM_EXIT_ACK_INTR_ON_EXIT () {0x8000;}' unless defined(&VM_EXIT_ACK_INTR_ON_EXIT);
    eval 'sub VM_EXIT_SAVE_IA32_PAT () {0x40000;}' unless defined(&VM_EXIT_SAVE_IA32_PAT);
    eval 'sub VM_EXIT_LOAD_IA32_PAT () {0x80000;}' unless defined(&VM_EXIT_LOAD_IA32_PAT);
    eval 'sub VM_ENTRY_IA32E_MODE () {0x200;}' unless defined(&VM_ENTRY_IA32E_MODE);
    eval 'sub VM_ENTRY_SMM () {0x400;}' unless defined(&VM_ENTRY_SMM);
    eval 'sub VM_ENTRY_DEACT_DUAL_MONITOR () {0x800;}' unless defined(&VM_ENTRY_DEACT_DUAL_MONITOR);
    eval 'sub VM_ENTRY_LOAD_IA32_PAT () {0x4000;}' unless defined(&VM_ENTRY_LOAD_IA32_PAT);
    eval("sub VIRTUAL_PROCESSOR_ID () { 0x00000000; }") unless defined(&VIRTUAL_PROCESSOR_ID);
    eval("sub GUEST_ES_SELECTOR () { 0x00000800; }") unless defined(&GUEST_ES_SELECTOR);
    eval("sub GUEST_CS_SELECTOR () { 0x00000802; }") unless defined(&GUEST_CS_SELECTOR);
    eval("sub GUEST_SS_SELECTOR () { 0x00000804; }") unless defined(&GUEST_SS_SELECTOR);
    eval("sub GUEST_DS_SELECTOR () { 0x00000806; }") unless defined(&GUEST_DS_SELECTOR);
    eval("sub GUEST_FS_SELECTOR () { 0x00000808; }") unless defined(&GUEST_FS_SELECTOR);
    eval("sub GUEST_GS_SELECTOR () { 0x0000080a; }") unless defined(&GUEST_GS_SELECTOR);
    eval("sub GUEST_LDTR_SELECTOR () { 0x0000080c; }") unless defined(&GUEST_LDTR_SELECTOR);
    eval("sub GUEST_TR_SELECTOR () { 0x0000080e; }") unless defined(&GUEST_TR_SELECTOR);
    eval("sub HOST_ES_SELECTOR () { 0x00000c00; }") unless defined(&HOST_ES_SELECTOR);
    eval("sub HOST_CS_SELECTOR () { 0x00000c02; }") unless defined(&HOST_CS_SELECTOR);
    eval("sub HOST_SS_SELECTOR () { 0x00000c04; }") unless defined(&HOST_SS_SELECTOR);
    eval("sub HOST_DS_SELECTOR () { 0x00000c06; }") unless defined(&HOST_DS_SELECTOR);
    eval("sub HOST_FS_SELECTOR () { 0x00000c08; }") unless defined(&HOST_FS_SELECTOR);
    eval("sub HOST_GS_SELECTOR () { 0x00000c0a; }") unless defined(&HOST_GS_SELECTOR);
    eval("sub HOST_TR_SELECTOR () { 0x00000c0c; }") unless defined(&HOST_TR_SELECTOR);
    eval("sub IO_BITMAP_A () { 0x00002000; }") unless defined(&IO_BITMAP_A);
    eval("sub IO_BITMAP_A_HIGH () { 0x00002001; }") unless defined(&IO_BITMAP_A_HIGH);
    eval("sub IO_BITMAP_B () { 0x00002002; }") unless defined(&IO_BITMAP_B);
    eval("sub IO_BITMAP_B_HIGH () { 0x00002003; }") unless defined(&IO_BITMAP_B_HIGH);
    eval("sub MSR_BITMAP () { 0x00002004; }") unless defined(&MSR_BITMAP);
    eval("sub MSR_BITMAP_HIGH () { 0x00002005; }") unless defined(&MSR_BITMAP_HIGH);
    eval("sub VM_EXIT_MSR_STORE_ADDR () { 0x00002006; }") unless defined(&VM_EXIT_MSR_STORE_ADDR);
    eval("sub VM_EXIT_MSR_STORE_ADDR_HIGH () { 0x00002007; }") unless defined(&VM_EXIT_MSR_STORE_ADDR_HIGH);
    eval("sub VM_EXIT_MSR_LOAD_ADDR () { 0x00002008; }") unless defined(&VM_EXIT_MSR_LOAD_ADDR);
    eval("sub VM_EXIT_MSR_LOAD_ADDR_HIGH () { 0x00002009; }") unless defined(&VM_EXIT_MSR_LOAD_ADDR_HIGH);
    eval("sub VM_ENTRY_MSR_LOAD_ADDR () { 0x0000200a; }") unless defined(&VM_ENTRY_MSR_LOAD_ADDR);
    eval("sub VM_ENTRY_MSR_LOAD_ADDR_HIGH () { 0x0000200b; }") unless defined(&VM_ENTRY_MSR_LOAD_ADDR_HIGH);
    eval("sub TSC_OFFSET () { 0x00002010; }") unless defined(&TSC_OFFSET);
    eval("sub TSC_OFFSET_HIGH () { 0x00002011; }") unless defined(&TSC_OFFSET_HIGH);
    eval("sub VIRTUAL_APIC_PAGE_ADDR () { 0x00002012; }") unless defined(&VIRTUAL_APIC_PAGE_ADDR);
    eval("sub VIRTUAL_APIC_PAGE_ADDR_HIGH () { 0x00002013; }") unless defined(&VIRTUAL_APIC_PAGE_ADDR_HIGH);
    eval("sub APIC_ACCESS_ADDR () { 0x00002014; }") unless defined(&APIC_ACCESS_ADDR);
    eval("sub APIC_ACCESS_ADDR_HIGH () { 0x00002015; }") unless defined(&APIC_ACCESS_ADDR_HIGH);
    eval("sub EPT_POINTER () { 0x0000201a; }") unless defined(&EPT_POINTER);
    eval("sub EPT_POINTER_HIGH () { 0x0000201b; }") unless defined(&EPT_POINTER_HIGH);
    eval("sub GUEST_PHYSICAL_ADDRESS () { 0x00002400; }") unless defined(&GUEST_PHYSICAL_ADDRESS);
    eval("sub GUEST_PHYSICAL_ADDRESS_HIGH () { 0x00002401; }") unless defined(&GUEST_PHYSICAL_ADDRESS_HIGH);
    eval("sub VMCS_LINK_POINTER () { 0x00002800; }") unless defined(&VMCS_LINK_POINTER);
    eval("sub VMCS_LINK_POINTER_HIGH () { 0x00002801; }") unless defined(&VMCS_LINK_POINTER_HIGH);
    eval("sub GUEST_IA32_DEBUGCTL () { 0x00002802; }") unless defined(&GUEST_IA32_DEBUGCTL);
    eval("sub GUEST_IA32_DEBUGCTL_HIGH () { 0x00002803; }") unless defined(&GUEST_IA32_DEBUGCTL_HIGH);
    eval("sub GUEST_IA32_PAT () { 0x00002804; }") unless defined(&GUEST_IA32_PAT);
    eval("sub GUEST_IA32_PAT_HIGH () { 0x00002805; }") unless defined(&GUEST_IA32_PAT_HIGH);
    eval("sub GUEST_PDPTR0 () { 0x0000280a; }") unless defined(&GUEST_PDPTR0);
    eval("sub GUEST_PDPTR0_HIGH () { 0x0000280b; }") unless defined(&GUEST_PDPTR0_HIGH);
    eval("sub GUEST_PDPTR1 () { 0x0000280c; }") unless defined(&GUEST_PDPTR1);
    eval("sub GUEST_PDPTR1_HIGH () { 0x0000280d; }") unless defined(&GUEST_PDPTR1_HIGH);
    eval("sub GUEST_PDPTR2 () { 0x0000280e; }") unless defined(&GUEST_PDPTR2);
    eval("sub GUEST_PDPTR2_HIGH () { 0x0000280f; }") unless defined(&GUEST_PDPTR2_HIGH);
    eval("sub GUEST_PDPTR3 () { 0x00002810; }") unless defined(&GUEST_PDPTR3);
    eval("sub GUEST_PDPTR3_HIGH () { 0x00002811; }") unless defined(&GUEST_PDPTR3_HIGH);
    eval("sub HOST_IA32_PAT () { 0x00002c00; }") unless defined(&HOST_IA32_PAT);
    eval("sub HOST_IA32_PAT_HIGH () { 0x00002c01; }") unless defined(&HOST_IA32_PAT_HIGH);
    eval("sub PIN_BASED_VM_EXEC_CONTROL () { 0x00004000; }") unless defined(&PIN_BASED_VM_EXEC_CONTROL);
    eval("sub CPU_BASED_VM_EXEC_CONTROL () { 0x00004002; }") unless defined(&CPU_BASED_VM_EXEC_CONTROL);
    eval("sub EXCEPTION_BITMAP () { 0x00004004; }") unless defined(&EXCEPTION_BITMAP);
    eval("sub PAGE_FAULT_ERROR_CODE_MASK () { 0x00004006; }") unless defined(&PAGE_FAULT_ERROR_CODE_MASK);
    eval("sub PAGE_FAULT_ERROR_CODE_MATCH () { 0x00004008; }") unless defined(&PAGE_FAULT_ERROR_CODE_MATCH);
    eval("sub CR3_TARGET_COUNT () { 0x0000400a; }") unless defined(&CR3_TARGET_COUNT);
    eval("sub VM_EXIT_CONTROLS () { 0x0000400c; }") unless defined(&VM_EXIT_CONTROLS);
    eval("sub VM_EXIT_MSR_STORE_COUNT () { 0x0000400e; }") unless defined(&VM_EXIT_MSR_STORE_COUNT);
    eval("sub VM_EXIT_MSR_LOAD_COUNT () { 0x00004010; }") unless defined(&VM_EXIT_MSR_LOAD_COUNT);
    eval("sub VM_ENTRY_CONTROLS () { 0x00004012; }") unless defined(&VM_ENTRY_CONTROLS);
    eval("sub VM_ENTRY_MSR_LOAD_COUNT () { 0x00004014; }") unless defined(&VM_ENTRY_MSR_LOAD_COUNT);
    eval("sub VM_ENTRY_INTR_INFO_FIELD () { 0x00004016; }") unless defined(&VM_ENTRY_INTR_INFO_FIELD);
    eval("sub VM_ENTRY_EXCEPTION_ERROR_CODE () { 0x00004018; }") unless defined(&VM_ENTRY_EXCEPTION_ERROR_CODE);
    eval("sub VM_ENTRY_INSTRUCTION_LEN () { 0x0000401a; }") unless defined(&VM_ENTRY_INSTRUCTION_LEN);
    eval("sub TPR_THRESHOLD () { 0x0000401c; }") unless defined(&TPR_THRESHOLD);
    eval("sub SECONDARY_VM_EXEC_CONTROL () { 0x0000401e; }") unless defined(&SECONDARY_VM_EXEC_CONTROL);
    eval("sub VM_INSTRUCTION_ERROR () { 0x00004400; }") unless defined(&VM_INSTRUCTION_ERROR);
    eval("sub VM_EXIT_REASON () { 0x00004402; }") unless defined(&VM_EXIT_REASON);
    eval("sub VM_EXIT_INTR_INFO () { 0x00004404; }") unless defined(&VM_EXIT_INTR_INFO);
    eval("sub VM_EXIT_INTR_ERROR_CODE () { 0x00004406; }") unless defined(&VM_EXIT_INTR_ERROR_CODE);
    eval("sub IDT_VECTORING_INFO_FIELD () { 0x00004408; }") unless defined(&IDT_VECTORING_INFO_FIELD);
    eval("sub IDT_VECTORING_ERROR_CODE () { 0x0000440a; }") unless defined(&IDT_VECTORING_ERROR_CODE);
    eval("sub VM_EXIT_INSTRUCTION_LEN () { 0x0000440c; }") unless defined(&VM_EXIT_INSTRUCTION_LEN);
    eval("sub VMX_INSTRUCTION_INFO () { 0x0000440e; }") unless defined(&VMX_INSTRUCTION_INFO);
    eval("sub GUEST_ES_LIMIT () { 0x00004800; }") unless defined(&GUEST_ES_LIMIT);
    eval("sub GUEST_CS_LIMIT () { 0x00004802; }") unless defined(&GUEST_CS_LIMIT);
    eval("sub GUEST_SS_LIMIT () { 0x00004804; }") unless defined(&GUEST_SS_LIMIT);
    eval("sub GUEST_DS_LIMIT () { 0x00004806; }") unless defined(&GUEST_DS_LIMIT);
    eval("sub GUEST_FS_LIMIT () { 0x00004808; }") unless defined(&GUEST_FS_LIMIT);
    eval("sub GUEST_GS_LIMIT () { 0x0000480a; }") unless defined(&GUEST_GS_LIMIT);
    eval("sub GUEST_LDTR_LIMIT () { 0x0000480c; }") unless defined(&GUEST_LDTR_LIMIT);
    eval("sub GUEST_TR_LIMIT () { 0x0000480e; }") unless defined(&GUEST_TR_LIMIT);
    eval("sub GUEST_GDTR_LIMIT () { 0x00004810; }") unless defined(&GUEST_GDTR_LIMIT);
    eval("sub GUEST_IDTR_LIMIT () { 0x00004812; }") unless defined(&GUEST_IDTR_LIMIT);
    eval("sub GUEST_ES_AR_BYTES () { 0x00004814; }") unless defined(&GUEST_ES_AR_BYTES);
    eval("sub GUEST_CS_AR_BYTES () { 0x00004816; }") unless defined(&GUEST_CS_AR_BYTES);
    eval("sub GUEST_SS_AR_BYTES () { 0x00004818; }") unless defined(&GUEST_SS_AR_BYTES);
    eval("sub GUEST_DS_AR_BYTES () { 0x0000481a; }") unless defined(&GUEST_DS_AR_BYTES);
    eval("sub GUEST_FS_AR_BYTES () { 0x0000481c; }") unless defined(&GUEST_FS_AR_BYTES);
    eval("sub GUEST_GS_AR_BYTES () { 0x0000481e; }") unless defined(&GUEST_GS_AR_BYTES);
    eval("sub GUEST_LDTR_AR_BYTES () { 0x00004820; }") unless defined(&GUEST_LDTR_AR_BYTES);
    eval("sub GUEST_TR_AR_BYTES () { 0x00004822; }") unless defined(&GUEST_TR_AR_BYTES);
    eval("sub GUEST_INTERRUPTIBILITY_INFO () { 0x00004824; }") unless defined(&GUEST_INTERRUPTIBILITY_INFO);
    eval("sub GUEST_ACTIVITY_STATE () { 0X00004826; }") unless defined(&GUEST_ACTIVITY_STATE);
    eval("sub GUEST_SYSENTER_CS () { 0x0000482A; }") unless defined(&GUEST_SYSENTER_CS);
    eval("sub HOST_IA32_SYSENTER_CS () { 0x00004c00; }") unless defined(&HOST_IA32_SYSENTER_CS);
    eval("sub CR0_GUEST_HOST_MASK () { 0x00006000; }") unless defined(&CR0_GUEST_HOST_MASK);
    eval("sub CR4_GUEST_HOST_MASK () { 0x00006002; }") unless defined(&CR4_GUEST_HOST_MASK);
    eval("sub CR0_READ_SHADOW () { 0x00006004; }") unless defined(&CR0_READ_SHADOW);
    eval("sub CR4_READ_SHADOW () { 0x00006006; }") unless defined(&CR4_READ_SHADOW);
    eval("sub CR3_TARGET_VALUE0 () { 0x00006008; }") unless defined(&CR3_TARGET_VALUE0);
    eval("sub CR3_TARGET_VALUE1 () { 0x0000600a; }") unless defined(&CR3_TARGET_VALUE1);
    eval("sub CR3_TARGET_VALUE2 () { 0x0000600c; }") unless defined(&CR3_TARGET_VALUE2);
    eval("sub CR3_TARGET_VALUE3 () { 0x0000600e; }") unless defined(&CR3_TARGET_VALUE3);
    eval("sub EXIT_QUALIFICATION () { 0x00006400; }") unless defined(&EXIT_QUALIFICATION);
    eval("sub GUEST_LINEAR_ADDRESS () { 0x0000640a; }") unless defined(&GUEST_LINEAR_ADDRESS);
    eval("sub GUEST_CR0 () { 0x00006800; }") unless defined(&GUEST_CR0);
    eval("sub GUEST_CR3 () { 0x00006802; }") unless defined(&GUEST_CR3);
    eval("sub GUEST_CR4 () { 0x00006804; }") unless defined(&GUEST_CR4);
    eval("sub GUEST_ES_BASE () { 0x00006806; }") unless defined(&GUEST_ES_BASE);
    eval("sub GUEST_CS_BASE () { 0x00006808; }") unless defined(&GUEST_CS_BASE);
    eval("sub GUEST_SS_BASE () { 0x0000680a; }") unless defined(&GUEST_SS_BASE);
    eval("sub GUEST_DS_BASE () { 0x0000680c; }") unless defined(&GUEST_DS_BASE);
    eval("sub GUEST_FS_BASE () { 0x0000680e; }") unless defined(&GUEST_FS_BASE);
    eval("sub GUEST_GS_BASE () { 0x00006810; }") unless defined(&GUEST_GS_BASE);
    eval("sub GUEST_LDTR_BASE () { 0x00006812; }") unless defined(&GUEST_LDTR_BASE);
    eval("sub GUEST_TR_BASE () { 0x00006814; }") unless defined(&GUEST_TR_BASE);
    eval("sub GUEST_GDTR_BASE () { 0x00006816; }") unless defined(&GUEST_GDTR_BASE);
    eval("sub GUEST_IDTR_BASE () { 0x00006818; }") unless defined(&GUEST_IDTR_BASE);
    eval("sub GUEST_DR7 () { 0x0000681a; }") unless defined(&GUEST_DR7);
    eval("sub GUEST_RSP () { 0x0000681c; }") unless defined(&GUEST_RSP);
    eval("sub GUEST_RIP () { 0x0000681e; }") unless defined(&GUEST_RIP);
    eval("sub GUEST_RFLAGS () { 0x00006820; }") unless defined(&GUEST_RFLAGS);
    eval("sub GUEST_PENDING_DBG_EXCEPTIONS () { 0x00006822; }") unless defined(&GUEST_PENDING_DBG_EXCEPTIONS);
    eval("sub GUEST_SYSENTER_ESP () { 0x00006824; }") unless defined(&GUEST_SYSENTER_ESP);
    eval("sub GUEST_SYSENTER_EIP () { 0x00006826; }") unless defined(&GUEST_SYSENTER_EIP);
    eval("sub HOST_CR0 () { 0x00006c00; }") unless defined(&HOST_CR0);
    eval("sub HOST_CR3 () { 0x00006c02; }") unless defined(&HOST_CR3);
    eval("sub HOST_CR4 () { 0x00006c04; }") unless defined(&HOST_CR4);
    eval("sub HOST_FS_BASE () { 0x00006c06; }") unless defined(&HOST_FS_BASE);
    eval("sub HOST_GS_BASE () { 0x00006c08; }") unless defined(&HOST_GS_BASE);
    eval("sub HOST_TR_BASE () { 0x00006c0a; }") unless defined(&HOST_TR_BASE);
    eval("sub HOST_GDTR_BASE () { 0x00006c0c; }") unless defined(&HOST_GDTR_BASE);
    eval("sub HOST_IDTR_BASE () { 0x00006c0e; }") unless defined(&HOST_IDTR_BASE);
    eval("sub HOST_IA32_SYSENTER_ESP () { 0x00006c10; }") unless defined(&HOST_IA32_SYSENTER_ESP);
    eval("sub HOST_IA32_SYSENTER_EIP () { 0x00006c12; }") unless defined(&HOST_IA32_SYSENTER_EIP);
    eval("sub HOST_RSP () { 0x00006c14; }") unless defined(&HOST_RSP);
    eval("sub HOST_RIP () { 0x00006c16; }") unless defined(&HOST_RIP);
    eval 'sub VMX_EXIT_REASONS_FAILED_VMENTRY () {0x80000000;}' unless defined(&VMX_EXIT_REASONS_FAILED_VMENTRY);
    eval 'sub EXIT_REASON_EXCEPTION_NMI () {0;}' unless defined(&EXIT_REASON_EXCEPTION_NMI);
    eval 'sub EXIT_REASON_EXTERNAL_INTERRUPT () {1;}' unless defined(&EXIT_REASON_EXTERNAL_INTERRUPT);
    eval 'sub EXIT_REASON_TRIPLE_FAULT () {2;}' unless defined(&EXIT_REASON_TRIPLE_FAULT);
    eval 'sub EXIT_REASON_PENDING_INTERRUPT () {7;}' unless defined(&EXIT_REASON_PENDING_INTERRUPT);
    eval 'sub EXIT_REASON_NMI_WINDOW () {8;}' unless defined(&EXIT_REASON_NMI_WINDOW);
    eval 'sub EXIT_REASON_TASK_SWITCH () {9;}' unless defined(&EXIT_REASON_TASK_SWITCH);
    eval 'sub EXIT_REASON_CPUID () {10;}' unless defined(&EXIT_REASON_CPUID);
    eval 'sub EXIT_REASON_HLT () {12;}' unless defined(&EXIT_REASON_HLT);
    eval 'sub EXIT_REASON_INVLPG () {14;}' unless defined(&EXIT_REASON_INVLPG);
    eval 'sub EXIT_REASON_RDPMC () {15;}' unless defined(&EXIT_REASON_RDPMC);
    eval 'sub EXIT_REASON_RDTSC () {16;}' unless defined(&EXIT_REASON_RDTSC);
    eval 'sub EXIT_REASON_VMCALL () {18;}' unless defined(&EXIT_REASON_VMCALL);
    eval 'sub EXIT_REASON_VMCLEAR () {19;}' unless defined(&EXIT_REASON_VMCLEAR);
    eval 'sub EXIT_REASON_VMLAUNCH () {20;}' unless defined(&EXIT_REASON_VMLAUNCH);
    eval 'sub EXIT_REASON_VMPTRLD () {21;}' unless defined(&EXIT_REASON_VMPTRLD);
    eval 'sub EXIT_REASON_VMPTRST () {22;}' unless defined(&EXIT_REASON_VMPTRST);
    eval 'sub EXIT_REASON_VMREAD () {23;}' unless defined(&EXIT_REASON_VMREAD);
    eval 'sub EXIT_REASON_VMRESUME () {24;}' unless defined(&EXIT_REASON_VMRESUME);
    eval 'sub EXIT_REASON_VMWRITE () {25;}' unless defined(&EXIT_REASON_VMWRITE);
    eval 'sub EXIT_REASON_VMOFF () {26;}' unless defined(&EXIT_REASON_VMOFF);
    eval 'sub EXIT_REASON_VMON () {27;}' unless defined(&EXIT_REASON_VMON);
    eval 'sub EXIT_REASON_CR_ACCESS () {28;}' unless defined(&EXIT_REASON_CR_ACCESS);
    eval 'sub EXIT_REASON_DR_ACCESS () {29;}' unless defined(&EXIT_REASON_DR_ACCESS);
    eval 'sub EXIT_REASON_IO_INSTRUCTION () {30;}' unless defined(&EXIT_REASON_IO_INSTRUCTION);
    eval 'sub EXIT_REASON_MSR_READ () {31;}' unless defined(&EXIT_REASON_MSR_READ);
    eval 'sub EXIT_REASON_MSR_WRITE () {32;}' unless defined(&EXIT_REASON_MSR_WRITE);
    eval 'sub EXIT_REASON_MWAIT_INSTRUCTION () {36;}' unless defined(&EXIT_REASON_MWAIT_INSTRUCTION);
    eval 'sub EXIT_REASON_MCE_DURING_VMENTRY () {41;}' unless defined(&EXIT_REASON_MCE_DURING_VMENTRY);
    eval 'sub EXIT_REASON_TPR_BELOW_THRESHOLD () {43;}' unless defined(&EXIT_REASON_TPR_BELOW_THRESHOLD);
    eval 'sub EXIT_REASON_APIC_ACCESS () {44;}' unless defined(&EXIT_REASON_APIC_ACCESS);
    eval 'sub EXIT_REASON_EPT_VIOLATION () {48;}' unless defined(&EXIT_REASON_EPT_VIOLATION);
    eval 'sub EXIT_REASON_EPT_MISCONFIG () {49;}' unless defined(&EXIT_REASON_EPT_MISCONFIG);
    eval 'sub EXIT_REASON_WBINVD () {54;}' unless defined(&EXIT_REASON_WBINVD);
    eval 'sub INTR_INFO_VECTOR_MASK () {0xff;}' unless defined(&INTR_INFO_VECTOR_MASK);
    eval 'sub INTR_INFO_INTR_TYPE_MASK () {0x700;}' unless defined(&INTR_INFO_INTR_TYPE_MASK);
    eval 'sub INTR_INFO_DELIVER_CODE_MASK () {0x800;}' unless defined(&INTR_INFO_DELIVER_CODE_MASK);
    eval 'sub INTR_INFO_UNBLOCK_NMI () {0x1000;}' unless defined(&INTR_INFO_UNBLOCK_NMI);
    eval 'sub INTR_INFO_VALID_MASK () {0x80000000;}' unless defined(&INTR_INFO_VALID_MASK);
    eval 'sub INTR_INFO_RESVD_BITS_MASK () {0x7ffff000;}' unless defined(&INTR_INFO_RESVD_BITS_MASK);
    eval 'sub VECTORING_INFO_VECTOR_MASK () { &INTR_INFO_VECTOR_MASK;}' unless defined(&VECTORING_INFO_VECTOR_MASK);
    eval 'sub VECTORING_INFO_TYPE_MASK () { &INTR_INFO_INTR_TYPE_MASK;}' unless defined(&VECTORING_INFO_TYPE_MASK);
    eval 'sub VECTORING_INFO_DELIVER_CODE_MASK () { &INTR_INFO_DELIVER_CODE_MASK;}' unless defined(&VECTORING_INFO_DELIVER_CODE_MASK);
    eval 'sub VECTORING_INFO_VALID_MASK () { &INTR_INFO_VALID_MASK;}' unless defined(&VECTORING_INFO_VALID_MASK);
    eval 'sub INTR_TYPE_EXT_INTR () {(0<< 8);}' unless defined(&INTR_TYPE_EXT_INTR);
    eval 'sub INTR_TYPE_NMI_INTR () {(2<< 8);}' unless defined(&INTR_TYPE_NMI_INTR);
    eval 'sub INTR_TYPE_HARD_EXCEPTION () {(3<< 8);}' unless defined(&INTR_TYPE_HARD_EXCEPTION);
    eval 'sub INTR_TYPE_SOFT_INTR () {(4<< 8);}' unless defined(&INTR_TYPE_SOFT_INTR);
    eval 'sub INTR_TYPE_SOFT_EXCEPTION () {(6<< 8);}' unless defined(&INTR_TYPE_SOFT_EXCEPTION);
    eval 'sub GUEST_INTR_STATE_STI () {0x1;}' unless defined(&GUEST_INTR_STATE_STI);
    eval 'sub GUEST_INTR_STATE_MOV_SS () {0x2;}' unless defined(&GUEST_INTR_STATE_MOV_SS);
    eval 'sub GUEST_INTR_STATE_SMI () {0x4;}' unless defined(&GUEST_INTR_STATE_SMI);
    eval 'sub GUEST_INTR_STATE_NMI () {0x8;}' unless defined(&GUEST_INTR_STATE_NMI);
    eval 'sub CONTROL_REG_ACCESS_NUM () {0x7;}' unless defined(&CONTROL_REG_ACCESS_NUM);
    eval 'sub CONTROL_REG_ACCESS_TYPE () {0x30;}' unless defined(&CONTROL_REG_ACCESS_TYPE);
    eval 'sub CONTROL_REG_ACCESS_REG () {0xf00;}' unless defined(&CONTROL_REG_ACCESS_REG);
    eval 'sub LMSW_SOURCE_DATA_SHIFT () {16;}' unless defined(&LMSW_SOURCE_DATA_SHIFT);
    eval 'sub LMSW_SOURCE_DATA () {(0xffff <<  &LMSW_SOURCE_DATA_SHIFT);}' unless defined(&LMSW_SOURCE_DATA);
    eval 'sub REG_EAX () {(0<< 8);}' unless defined(&REG_EAX);
    eval 'sub REG_ECX () {(1<< 8);}' unless defined(&REG_ECX);
    eval 'sub REG_EDX () {(2<< 8);}' unless defined(&REG_EDX);
    eval 'sub REG_EBX () {(3<< 8);}' unless defined(&REG_EBX);
    eval 'sub REG_ESP () {(4<< 8);}' unless defined(&REG_ESP);
    eval 'sub REG_EBP () {(5<< 8);}' unless defined(&REG_EBP);
    eval 'sub REG_ESI () {(6<< 8);}' unless defined(&REG_ESI);
    eval 'sub REG_EDI () {(7<< 8);}' unless defined(&REG_EDI);
    eval 'sub REG_R8 () {(8<< 8);}' unless defined(&REG_R8);
    eval 'sub REG_R9 () {(9<< 8);}' unless defined(&REG_R9);
    eval 'sub REG_R10 () {(10<< 8);}' unless defined(&REG_R10);
    eval 'sub REG_R11 () {(11<< 8);}' unless defined(&REG_R11);
    eval 'sub REG_R12 () {(12<< 8);}' unless defined(&REG_R12);
    eval 'sub REG_R13 () {(13<< 8);}' unless defined(&REG_R13);
    eval 'sub REG_R14 () {(14<< 8);}' unless defined(&REG_R14);
    eval 'sub REG_R15 () {(15<< 8);}' unless defined(&REG_R15);
    eval 'sub DEBUG_REG_ACCESS_NUM () {0x7;}' unless defined(&DEBUG_REG_ACCESS_NUM);
    eval 'sub DEBUG_REG_ACCESS_TYPE () {0x10;}' unless defined(&DEBUG_REG_ACCESS_TYPE);
    eval 'sub TYPE_MOV_TO_DR () {(0<< 4);}' unless defined(&TYPE_MOV_TO_DR);
    eval 'sub TYPE_MOV_FROM_DR () {(1<< 4);}' unless defined(&TYPE_MOV_FROM_DR);
    eval 'sub DEBUG_REG_ACCESS_REG {
        my($eq) = @_;
	    eval q(((($eq) >> 8) & 0xf));
    }' unless defined(&DEBUG_REG_ACCESS_REG);
    eval 'sub SEGMENT_AR_L_MASK () {(1<< 13);}' unless defined(&SEGMENT_AR_L_MASK);
    eval 'sub AR_TYPE_ACCESSES_MASK () {1;}' unless defined(&AR_TYPE_ACCESSES_MASK);
    eval 'sub AR_TYPE_READABLE_MASK () {(1<< 1);}' unless defined(&AR_TYPE_READABLE_MASK);
    eval 'sub AR_TYPE_WRITEABLE_MASK () {(1<< 2);}' unless defined(&AR_TYPE_WRITEABLE_MASK);
    eval 'sub AR_TYPE_CODE_MASK () {(1<< 3);}' unless defined(&AR_TYPE_CODE_MASK);
    eval 'sub AR_TYPE_MASK () {0xf;}' unless defined(&AR_TYPE_MASK);
    eval 'sub AR_TYPE_BUSY_64_TSS () {11;}' unless defined(&AR_TYPE_BUSY_64_TSS);
    eval 'sub AR_TYPE_BUSY_32_TSS () {11;}' unless defined(&AR_TYPE_BUSY_32_TSS);
    eval 'sub AR_TYPE_BUSY_16_TSS () {3;}' unless defined(&AR_TYPE_BUSY_16_TSS);
    eval 'sub AR_TYPE_LDT () {2;}' unless defined(&AR_TYPE_LDT);
    eval 'sub AR_UNUSABLE_MASK () {(1<< 16);}' unless defined(&AR_UNUSABLE_MASK);
    eval 'sub AR_S_MASK () {(1<< 4);}' unless defined(&AR_S_MASK);
    eval 'sub AR_P_MASK () {(1<< 7);}' unless defined(&AR_P_MASK);
    eval 'sub AR_L_MASK () {(1<< 13);}' unless defined(&AR_L_MASK);
    eval 'sub AR_DB_MASK () {(1<< 14);}' unless defined(&AR_DB_MASK);
    eval 'sub AR_G_MASK () {(1<< 15);}' unless defined(&AR_G_MASK);
    eval 'sub AR_DPL_SHIFT () {5;}' unless defined(&AR_DPL_SHIFT);
    eval 'sub AR_DPL {
        my($ar) = @_;
	    eval q(((($ar) >>  &AR_DPL_SHIFT) & 3));
    }' unless defined(&AR_DPL);
    eval 'sub AR_RESERVD_MASK () {0xfffe0f00;}' unless defined(&AR_RESERVD_MASK);
    eval 'sub TSS_PRIVATE_MEMSLOT () {( &KVM_MEMORY_SLOTS + 0);}' unless defined(&TSS_PRIVATE_MEMSLOT);
    eval 'sub APIC_ACCESS_PAGE_PRIVATE_MEMSLOT () {( &KVM_MEMORY_SLOTS + 1);}' unless defined(&APIC_ACCESS_PAGE_PRIVATE_MEMSLOT);
    eval 'sub IDENTITY_PAGETABLE_PRIVATE_MEMSLOT () {( &KVM_MEMORY_SLOTS + 2);}' unless defined(&IDENTITY_PAGETABLE_PRIVATE_MEMSLOT);
    eval 'sub VMX_NR_VPIDS () {(1<< 16);}' unless defined(&VMX_NR_VPIDS);
    eval 'sub VMX_VPID_EXTENT_SINGLE_CONTEXT () {1;}' unless defined(&VMX_VPID_EXTENT_SINGLE_CONTEXT);
    eval 'sub VMX_VPID_EXTENT_ALL_CONTEXT () {2;}' unless defined(&VMX_VPID_EXTENT_ALL_CONTEXT);
    eval 'sub VMX_EPT_EXTENT_INDIVIDUAL_ADDR () {0;}' unless defined(&VMX_EPT_EXTENT_INDIVIDUAL_ADDR);
    eval 'sub VMX_EPT_EXTENT_CONTEXT () {1;}' unless defined(&VMX_EPT_EXTENT_CONTEXT);
    eval 'sub VMX_EPT_EXTENT_GLOBAL () {2;}' unless defined(&VMX_EPT_EXTENT_GLOBAL);
    eval 'sub VMX_EPT_EXECUTE_ONLY_BIT () {(1);}' unless defined(&VMX_EPT_EXECUTE_ONLY_BIT);
    eval 'sub VMX_EPT_PAGE_WALK_4_BIT () {(1 << 6);}' unless defined(&VMX_EPT_PAGE_WALK_4_BIT);
    eval 'sub VMX_EPTP_UC_BIT () {(1 << 8);}' unless defined(&VMX_EPTP_UC_BIT);
    eval 'sub VMX_EPTP_WB_BIT () {(1 << 14);}' unless defined(&VMX_EPTP_WB_BIT);
    eval 'sub VMX_EPT_2MB_PAGE_BIT () {(1 << 16);}' unless defined(&VMX_EPT_2MB_PAGE_BIT);
    eval 'sub VMX_EPT_EXTENT_INDIVIDUAL_BIT () {(1 << 24);}' unless defined(&VMX_EPT_EXTENT_INDIVIDUAL_BIT);
    eval 'sub VMX_EPT_EXTENT_CONTEXT_BIT () {(1 << 25);}' unless defined(&VMX_EPT_EXTENT_CONTEXT_BIT);
    eval 'sub VMX_EPT_EXTENT_GLOBAL_BIT () {(1 << 26);}' unless defined(&VMX_EPT_EXTENT_GLOBAL_BIT);
    eval 'sub VMX_EPT_DEFAULT_GAW () {3;}' unless defined(&VMX_EPT_DEFAULT_GAW);
    eval 'sub VMX_EPT_MAX_GAW () {0x4;}' unless defined(&VMX_EPT_MAX_GAW);
    eval 'sub VMX_EPT_MT_EPTE_SHIFT () {3;}' unless defined(&VMX_EPT_MT_EPTE_SHIFT);
    eval 'sub VMX_EPT_GAW_EPTP_SHIFT () {3;}' unless defined(&VMX_EPT_GAW_EPTP_SHIFT);
    eval 'sub VMX_EPT_DEFAULT_MT () {0x6;}' unless defined(&VMX_EPT_DEFAULT_MT);
    eval 'sub VMX_EPT_READABLE_MASK () {0x1;}' unless defined(&VMX_EPT_READABLE_MASK);
    eval 'sub VMX_EPT_WRITABLE_MASK () {0x2;}' unless defined(&VMX_EPT_WRITABLE_MASK);
    eval 'sub VMX_EPT_EXECUTABLE_MASK () {0x4;}' unless defined(&VMX_EPT_EXECUTABLE_MASK);
    eval 'sub VMX_EPT_IGMT_BIT () {(1 << 6);}' unless defined(&VMX_EPT_IGMT_BIT);
    eval 'sub VMX_EPT_IDENTITY_PAGETABLE_ADDR () {0xfffbc000;}' unless defined(&VMX_EPT_IDENTITY_PAGETABLE_ADDR);
    eval 'sub ASM_VMX_VMCLEAR_RAX () {".byte 0x66, 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMCLEAR_RAX);
    eval 'sub ASM_VMX_VMLAUNCH () {".byte 0x0f, 0x01, 0xc2";}' unless defined(&ASM_VMX_VMLAUNCH);
    eval 'sub ASM_VMX_VMRESUME () {".byte 0x0f, 0x01, 0xc3";}' unless defined(&ASM_VMX_VMRESUME);
    eval 'sub ASM_VMX_VMPTRLD_RAX () {".byte 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMPTRLD_RAX);
    eval 'sub ASM_VMX_VMREAD_RDX_RAX () {".byte 0x0f, 0x78, 0xd0";}' unless defined(&ASM_VMX_VMREAD_RDX_RAX);
    eval 'sub ASM_VMX_VMWRITE_RAX_RDX () {".byte 0x0f, 0x79, 0xd0";}' unless defined(&ASM_VMX_VMWRITE_RAX_RDX);
    eval 'sub ASM_VMX_VMWRITE_RSP_RDX () {".byte 0x0f, 0x79, 0xd4";}' unless defined(&ASM_VMX_VMWRITE_RSP_RDX);
    eval 'sub ASM_VMX_VMXOFF () {".byte 0x0f, 0x01, 0xc4";}' unless defined(&ASM_VMX_VMXOFF);
    eval 'sub ASM_VMX_VMXON_RAX () {".byte 0xf3, 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMXON_RAX);
    eval 'sub ASM_VMX_INVEPT () {".byte 0x66, 0x0f, 0x38, 0x80, 0x08";}' unless defined(&ASM_VMX_INVEPT);
    eval 'sub ASM_VMX_INVVPID () {".byte 0x66, 0x0f, 0x38, 0x81, 0x08";}' unless defined(&ASM_VMX_INVVPID);
}
1;
