require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_KEXEC_H)) {
    eval 'sub _X86_64_KEXEC_H () {1;}' unless defined(&_X86_64_KEXEC_H);
    eval 'sub PA_CONTROL_PAGE () {0;}' unless defined(&PA_CONTROL_PAGE);
    eval 'sub VA_CONTROL_PAGE () {1;}' unless defined(&VA_CONTROL_PAGE);
    eval 'sub PA_PGD () {2;}' unless defined(&PA_PGD);
    eval 'sub VA_PGD () {3;}' unless defined(&VA_PGD);
    eval 'sub PA_PUD_0 () {4;}' unless defined(&PA_PUD_0);
    eval 'sub VA_PUD_0 () {5;}' unless defined(&VA_PUD_0);
    eval 'sub PA_PMD_0 () {6;}' unless defined(&PA_PMD_0);
    eval 'sub VA_PMD_0 () {7;}' unless defined(&VA_PMD_0);
    eval 'sub PA_PTE_0 () {8;}' unless defined(&PA_PTE_0);
    eval 'sub VA_PTE_0 () {9;}' unless defined(&VA_PTE_0);
    eval 'sub PA_PUD_1 () {10;}' unless defined(&PA_PUD_1);
    eval 'sub VA_PUD_1 () {11;}' unless defined(&VA_PUD_1);
    eval 'sub PA_PMD_1 () {12;}' unless defined(&PA_PMD_1);
    eval 'sub VA_PMD_1 () {13;}' unless defined(&VA_PMD_1);
    eval 'sub PA_PTE_1 () {14;}' unless defined(&PA_PTE_1);
    eval 'sub VA_PTE_1 () {15;}' unless defined(&VA_PTE_1);
    eval 'sub PA_TABLE_PAGE () {16;}' unless defined(&PA_TABLE_PAGE);
    eval 'sub PAGES_NR () {17;}' unless defined(&PAGES_NR);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/string.ph';
	require 'asm/page.ph';
	require 'asm/ptrace.ph';
	eval 'sub KEXEC_SOURCE_MEMORY_LIMIT () {(0xffffffffff);}' unless defined(&KEXEC_SOURCE_MEMORY_LIMIT);
	eval 'sub KEXEC_DESTINATION_MEMORY_LIMIT () {(0xffffffffff);}' unless defined(&KEXEC_DESTINATION_MEMORY_LIMIT);
	eval 'sub KEXEC_CONTROL_MEMORY_LIMIT () {(0xffffffffff);}' unless defined(&KEXEC_CONTROL_MEMORY_LIMIT);
	eval 'sub KEXEC_CONTROL_CODE_SIZE () {(4096 + 4096);}' unless defined(&KEXEC_CONTROL_CODE_SIZE);
	eval 'sub KEXEC_ARCH () { &KEXEC_ARCH_X86_64;}' unless defined(&KEXEC_ARCH);
	eval 'sub MAX_NOTE_BYTES () {1024;}' unless defined(&MAX_NOTE_BYTES);
	if(defined(&CONFIG_XEN)) {
	    eval 'sub KEXEC_ARCH_HAS_PAGE_MACROS () {1;}' unless defined(&KEXEC_ARCH_HAS_PAGE_MACROS);
	    eval 'sub kexec_page_to_pfn {
	        my($page) = @_;
    		eval q( &pfn_to_mfn( &page_to_pfn($page)));
	    }' unless defined(&kexec_page_to_pfn);
	    eval 'sub kexec_pfn_to_page {
	        my($pfn) = @_;
    		eval q( &pfn_to_page( &mfn_to_pfn($pfn)));
	    }' unless defined(&kexec_pfn_to_page);
	    eval 'sub kexec_virt_to_phys {
	        my($addr) = @_;
    		eval q( &virt_to_machine($addr));
	    }' unless defined(&kexec_virt_to_phys);
	    eval 'sub kexec_phys_to_virt {
	        my($addr) = @_;
    		eval q( &phys_to_virt( &machine_to_phys($addr)));
	    }' unless defined(&kexec_phys_to_virt);
	}
    }
}
1;
